#!/bin/bash
# ------------------------------------------------------------------------------
# CCM Payload
# ------------------------------------------------------------------------------
cmd pwr override 1
echo "***** STARTING INSTALL *****"
echo "Setting Variables"


# ------------- Set Required Payload Values -------------
# Select Spreader Controller EPOKE / CS550 / CIRUS
SPREADER_SELECT="CIRUS"

# Set baud rate for Controller
SPREADER_BAUD_RATE=9600

# RESET or KEEP else no seasonal files are touched
SEASONALRESET="KEEP"

# Set USR_STR Report Destination 
REP_DEST="cypressvue.com"

# Set SpreaderApp.zip curl location 
URL="http://filestore.cypress.bc.ca/files/repository/openctm/ctm200r2/SpreaderApps/3.2"

# ------------------------------------------------------------------------------
# Other Variables
TMP_DIR="/tmp/spreader"
INSTALL_DIR="/var/data/reports/scripts"
SPREADER_FILE="SpreaderApp_3.2"
# ------------------------------------------------------------------------------

main () {
	getFiles
	checkUninstall
	copyFilesToDir
	configApp
	setRepDest
	echo "***** INSTALL COMPLETE *****"
}

# Download Spreaderapp files and modify
getFiles() {
	echo "Downloading and setting up spreader files"
	curl --insecure "$URL/$SPREADER_FILE.zip" -o /tmp/$SPREADER_FILE.zip
	mkdir -p $TMP_DIR
	unzip  -o /tmp/$SPREADER_FILE.zip -d $TMP_DIR
	
	dos2unix $TMP_DIR/$SPREADER_FILE/report100.sh
	dos2unix $TMP_DIR/$SPREADER_FILE/controller/*
	dos2unix $TMP_DIR/$SPREADER_FILE/config/*
	chmod u+x $TMP_DIR/$SPREADER_FILE/report100.sh
	chmod u+x $TMP_DIR/$SPREADER_FILE/controller/*
	chmod u+x $TMP_DIR/$SPREADER_FILE/config/*
}

copyFilesToDir () {
	echo "Copying New Spreader Files to Correct Directory"
	cp -r $TMP_DIR/$SPREADER_FILE/* $INSTALL_DIR
	sleep 1
}

checkUninstall () {
	source $TMP_DIR/$SPREADER_FILE/config/uninstall.sh $SEASONALRESET
}

configApp () {
	source $INSTALL_DIR/config/configApp.sh $SPREADER_SELECT $SPREADER_BAUD_RATE $SEASONALRESET
}

setRepDest() {
    if [ $REP_DEST  != "cypressvue.com" ]; then
        echo " Setting Report Destination to $REP_DEST"
        cmd gpsremip 8 "$REP_DEST"
    else
        echo "Report Destination is default: cypressvue.com"
    fi
}

main
cmd save
(sleep 30; cmd pwr mode 2) &
