#!/bin/bash
# 
# This script gets triggered by report999.sh on powerup.
# Report99 will check if this script is running every 35 seconds. It will run it if it is not.
# 
INSTALL_DIR="/var/data/reports/scripts"

while true
	do
		# Check if serial baudrate is set
		if [[ $(stty -F /dev/ttyO0 | sed -nr 's/.*speed (.*) baud.*/\1/p') = "9600" ]];
		then 
		# If set correctly, then collect serial_data
			timeout -t 20 cat /dev/ttyO0 > /tmp/serial_data.txt
		else
		# Else, set baud rate and collect serial_data
			stty -F /dev/ttyO0 9600
			timeout -t 20 cat /dev/ttyO0 > /tmp/serial_data.txt
		fi
		# after serial data is collected, run the app
		# if app takes longer than 30s to run, then break, sleep 5 and repeat
		timeout -t 30 python $INSTALL_DIR/controller/spreader.py CIRUS;
	done
	
